package net.locusworks.common.net.ssl;

import java.security.KeyManagementException;
import java.security.NoSuchAlgorithmException;
import java.security.SecureRandom;

import javax.net.ssl.SSLContext;
import javax.net.ssl.TrustManager;

import org.apache.http.client.HttpClient;
import org.apache.http.conn.ssl.SSLConnectionSocketFactory;
import org.apache.http.impl.client.HttpClientBuilder;

import net.locusworks.common.net.certmanagers.TrustAllCertsManager;
import net.locusworks.common.net.hostverifiers.AllHostValidVerifyer;

public class SSLManager {
  
  public static final String[] TLS = new String[] {"TLSv1", "TLSv1.1", "TLSv1.2"};
  
  public static HttpClient getTrustAllTLSClient() throws NoSuchAlgorithmException, KeyManagementException {
    SSLContext context = SSLContext.getInstance("TLS");
    context.init(null, new TrustManager[] { new TrustAllCertsManager() }, new SecureRandom());
    
    SSLConnectionSocketFactory sslsf = new SSLConnectionSocketFactory(context, TLS, null, new AllHostValidVerifyer());
    
    return HttpClientBuilder.create().setSSLSocketFactory(sslsf).build();
  }

}
